package application;

import javafx.application.Application;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

public class Main extends Application {

	@Override
	public void start(Stage primaryStage) throws Exception {
		FXMLLoader loader = new FXMLLoader(getClass().getResource("view/RootLayout.fxml"));
		BorderPane bp = loader.load();
		Scene scene = new Scene(bp);
		scene.getStylesheets().add(getClass().getResource("view/application.css").toExternalForm());
		
		primaryStage.setScene(scene);
		primaryStage.show();
		
		Circle c = new Circle(200, 200, 20);
		c.setId("myID");
		
		c.setOnMouseEntered(new EventHandler<MouseEvent>() {

			@Override
			public void handle(MouseEvent event) {
				c.setRadius(100);
			}
		});
		
		bp.getChildren().add(c);
	}

	public static void main(String[] args) {
		launch(args);
	}

}
