package application.controller;

import application.model.Player;
import javafx.application.Platform;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.concurrent.Task;
import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.TableColumn.CellDataFeatures;
import javafx.util.Callback;

public class RootController {
	@FXML
	private Label l1;
	
	@FXML
	private Button b1;
	
	@FXML
	private Button b2;
	
	@FXML
	private TableView<Player> table;
	
	@FXML
	private TableColumn<Player, String> name;
	
	@FXML
	private TableColumn<Player, String> score;
	
	@FXML
	private void initialize() {
		// bindet Zellinhalte an Werte
		name.setCellValueFactory(new Callback<TableColumn.CellDataFeatures<Player,String>, ObservableValue<String>>() {
			
			@Override
			public ObservableValue<String> call(CellDataFeatures<Player, String> param) {
				return param.getValue().nameProperty();
			}
		});
		
		score.setCellValueFactory(new Callback<TableColumn.CellDataFeatures<Player,String>, ObservableValue<String>>() {

			@Override
			public ObservableValue<String> call(CellDataFeatures<Player, String> param) {
				return param.getValue().scoreProperty().asString();
			}
		});
		
		// Änderungen an dieser Liste werden automatisch an View gemeldet
		ObservableList<Player> list = FXCollections.observableArrayList();
		list.add(new Player("Alice", 4));
		list.add(new Player("Bob", 2));
		list.add(new Player("Lisa", 5));
		list.add(new Player("Peter", 4));
		
		table.setItems(list);
	}
	
	@FXML
	private void handleClick() {
		Task<Void> t = new Task<Void>() {

			@Override
			protected Void call() throws Exception {
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				Platform.runLater(new Runnable() {
					
					@Override
					public void run() {
						Alert a = new Alert(AlertType.INFORMATION);
						a.showAndWait();
					}
				});
				return null;
			}
		};
		
		Thread thread = new Thread(t);
		thread.setDaemon(true);
		thread.start();
	}
}
